#!/usr/bin/env python

import pygame
import sys
import math
import nacitac

images = nacitac.Nacitac()

pygame.init()

mapXY= (800, 540)
screen = pygame.display.set_mode(mapXY)
pygame.display.set_caption('Paper World')

pygame.mouse.set_visible(0)
pygame.mouse.set_pos(screen.get_width()/2.0, screen.get_height()/2.0)
soumys = pygame.mouse.get_pos()

men = []

gravitace = 6

wall = (255,255,0,255)
danger = (255,0,0,255)
rope = (0,0,255,255)
exit = (255,0,255,255)
fps = 20
globalizacni = 0

class Man:
    deltaTime = 1.0/fps
    pixelsPerMeter = 40
    accelerationPerMouse = 0.004

    def __init__(self, obr, mapa, hp, seznam):
        self.seznam = seznam
        self.sou = seznam[globalizacni]
        self.obr = images.loadImage(obr)
        self.polomer = 10
        self.accel = [0, 0]
        self.speed = [0, 0]
        self.obrx = self.obr.get_width()//2
        self.obry = self.obr.get_height()//2
        self.hp = hp
        
        self.tolerance = 3
        self.mapa = mapa

        self.preparePixels()

    def preparePixels(self):
        self.pixel_1 = self.mapa.getAt((self.sou[0]-self.obrx+self.tolerance, self.sou[1]-self.obry))
        self.pixel_2 = self.mapa.getAt((self.sou[0]+self.obrx-self.tolerance, self.sou[1]-self.obry))
        self.pixel_3 = self.mapa.getAt((self.sou[0]+self.obrx, self.sou[1]-self.obry+self.tolerance))
        self.pixel_4 = self.mapa.getAt((self.sou[0]+self.obrx, self.sou[1]+self.obry-self.tolerance))
        self.pixel_5 = self.mapa.getAt((self.sou[0]+self.obrx-self.tolerance, self.sou[1]+self.obry))
        self.pixel_6 = self.mapa.getAt((self.sou[0]-self.obrx+self.tolerance, self.sou[1]+self.obry))
        self.pixel_7 = self.mapa.getAt((self.sou[0]-self.obrx, self.sou[1]+self.obry-self.tolerance))
        self.pixel_8 = self.mapa.getAt((self.sou[0]-self.obrx, self.sou[1]-self.obry+self.tolerance))

        self.pixel_jump = self.mapa.getAt((self.sou[0]+self.obrx-self.tolerance, self.sou[1]+self.obry+15))
        self.pixel_jump2 = self.mapa.getAt((self.sou[0]-self.obrx+self.tolerance, self.sou[1]+self.obry+15))

    def drawMan(self, screen):
        screen.blit(self.obr, (self.sou[0]-self.obrx, self.sou[1]-self.obry))

    def moveMan(self, keys):
        global globalizacni

        maxAccel = 5
        maxSpeed = 15
        dt = Man.deltaTime
        soumys = pygame.mouse.get_pos()

        self.speed[1] += gravitace * dt

        if self.pixel_1 == rope or self.pixel_2 == rope:
            self.speed[1] /= 2
            self.speed[1] -= 3*gravitace *dt

        self.accel[0] = (soumys[0] - screen.get_width()/2.0) * Man.accelerationPerMouse / (dt*dt)
        #self.accel[1] = soumys[1] - screen.get_height()/2.0

        if self.accel[0] > maxAccel:
            self.accel[0] = maxAccel
        elif self.accel[0] < -maxAccel:
            self.accel[0] = -maxAccel
        #if self.accel[1] > maxAccel:
        #    self.accel[1] = maxAccel
        #elif self.accel[1] < -maxAccel:
        #    self.accel[1] = -maxAccel

        self.speed[0] += self.accel[0] * dt
        self.speed[1] += self.accel[1] * dt

        if self.speed[0] > maxSpeed:
            self.speed[0] = maxSpeed
        elif self.speed[0] < -maxSpeed:
            self.speed[0] = -maxSpeed
        #if self.speed[1] > maxSpeed:
        #    self.speed[1] = maxSpeed
        #elif self.speed[1] < -maxSpeed:
        #    self.speed[1] = -maxSpeed

        oldSou = self.sou[:]
        self.sou[0] += Man.pixelsPerMeter * self.speed[0] * dt
        self.sou[1] += Man.pixelsPerMeter * self.speed[1] * dt
        self.sou[0] = int(self.sou[0] + 0.5)
        self.sou[1] = int(self.sou[1] + 0.5)

        pygame.mouse.set_pos(screen.get_width()/2.0, screen.get_height()/2.0)

        self.preparePixels()
        
        if self.pixel_1 == exit or self.pixel_2 == exit or self.pixel_3 == exit or self.pixel_4 == exit or self.pixel_5 == exit or self.pixel_6 == exit or self.pixel_7 == exit or self.pixel_8 == exit:
            globalizacni += 1
            self.speed = [0,0]
            self.accel = [0,0]
            self.sou = self.seznam[globalizacni]
            if globalizacni == 1:
                mapa.terrain = pygame.image.load("images/map21.png")
                mapa.bg = pygame.image.load("images/map23.png")
                mapa.fg = pygame.image.load("images/map22.png")
            elif globalizacni == 2:
                mapa.terrain = pygame.image.load("images/map31.png")
                mapa.bg = pygame.image.load("images/map33.png")
                mapa.fg = pygame.image.load("images/map32.png")


        if self.pixel_1 == danger or self.pixel_2 == danger or self.pixel_3 == danger or self.pixel_4 == danger or self.pixel_5 == danger or self.pixel_6 == danger or self.pixel_7 == danger or self.pixel_8 == danger:
            self.hp -= 1

        if self.hp <= 0:
            if globalizacni == 0:
                self.sou = [120,150]
            elif globalizacni == 1:
                self.sou = [60,300]
            elif globalizacni == 2:
                self.sou = [80,80]
            self.hp = 5

        if self.pixel_7 == wall or self.pixel_8 == wall:
            self.sou[0] = oldSou[0]
            self.speed[0] = -self.speed[0]/3.0
        if self.pixel_3 == wall or self.pixel_4 == wall:
            self.sou[0] = oldSou[0]
            self.speed[0] = -self.speed[0]/3.0
        if self.pixel_1 == wall or self.pixel_2 == wall:
            self.sou[1] = oldSou[1]
            self.speed[1] = abs(self.speed[1]/3.0)
        if self.pixel_5 == wall or self.pixel_6 == wall:
            self.sou[1] = oldSou[1]
            self.speed[1] = -self.speed[1]/3.0

        self.speed[0] *= 0.96
        self.speed[1] *= 0.99

        if self.pixel_jump == wall or self.pixel_jump2 == wall:
            if pressed:
                self.speed[1] -= 3

class Map:

    def __init__(self, terrain, bg, fg):
        self.terrain = pygame.image.load(terrain)
        self.bg = pygame.image.load(bg).convert()
        self.fg = pygame.image.load(fg).convert_alpha()
 
    def drawBG(self, screen):
        screen.blit(self.bg, (0,0))

    def drawFG(self, screen):
        screen.blit(self.fg, (0,0))

    def getAt(self, sou):
        if sou[0] < 0 or sou[0] >= self.terrain.get_width():
            return wall
        if sou[1] < 0 or sou[1] >= self.terrain.get_height():
            return wall

        return self.terrain.get_at(sou)

mapa = Map("images/map11.png", "images/map13.png", "images/map12.png")

seznamak = [[120,150],[60,300],[80,80],[400,270]]

paperboy = Man("images/man.png", mapa, 5, seznamak)

men.append(paperboy)

hodiny = pygame.time.Clock()

# intro
intro = images.loadImage("images/intro.png")
screen.blit(intro, (0, 0))
pygame.display.flip()

while 1:
    for event in pygame.event.get():
        if event.type == pygame.QUIT:
            sys.exit()
    keys = pygame.key.get_pressed()
    if keys[pygame.K_ESCAPE]:
        sys.exit()
    elif event.type == pygame.MOUSEBUTTONDOWN:
        break

while 1:

    hodiny.tick(fps)

    # outro
    if globalizacni == 3:
        outro = images.loadImage("images/outro.png")
        screen.blit(outro, (0, 0))
        pygame.display.flip()

        while 1:
            for event in pygame.event.get():
                if event.type == pygame.QUIT:
                    sys.exit()
            keys = pygame.key.get_pressed()
            if keys[pygame.K_ESCAPE]:
                sys.exit()
            elif event.type == pygame.MOUSEBUTTONDOWN:
                sys.exit()

    keys = pygame.key.get_pressed()
    pressed = False

    for event in pygame.event.get():
        if event.type == pygame.QUIT:
            sys.exit()
        elif event.type == pygame.MOUSEBUTTONDOWN:
            pressed = True
    if keys[pygame.K_ESCAPE]:
        sys.exit()

    mapa.drawBG(screen)

    for man in men:
        man.moveMan(keys)
        man.drawMan(screen)
        
    mapa.drawFG(screen)
            
    pygame.display.flip()
    screen.fill((0, 0, 0)) 
